Bug 10360 - xfs runs out of memory and gets killed
: xfs runs out of memory and gets killed
Status: CLOSED WONTFIX
: Sisyphus
(All bugs in Sisyphus/xorg-x11-xfs)
: unstable
: all Linux
: P2 normal
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2006-12-03 13:46 by
Modified: 2008-03-14 03:34 (History)


Attachments
/etc/X11/fs/config (1.64 KB, application/octet-stream)
2006-12-03 13:47, Mikhail Yakshin
no flags Details


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2006-12-03 13:46:50
Проявляется такое поведение xfs: после некоторых действий с некоторыми
программами, очевидно, связанных с запросом новых видов шрифтов у xfs, у xfs
что-то переклинивает внутри и он начинает есть память в бесконечном цикле,
где-то по несколько мегабайт в секунду. При этом, понятно, уже ни на какие
запросы не отвечает, программа, запросившая шрифт, делает вид, что висит, пока
он xfs не съест всю память и не будет убит ядром за это. После этого программа
"отвисает" и обычно довольствуется неким substitute-шрифтом, видимо, из кэша.

Перезапуск (service xfs restart) после такого помогает на некоторые время, до
следующего такого запроса. 100% четких закономерностей выявить не удалось.

Регулярно и достаточно воспроизводимо такое бывает при работе с GNU emacs / gtk
с его настройками по умолчанию, а именно (не всегда, а где-то в 30% случаев),
когда наводишь мышкой на некий выбираемый элемент в буфере, например, выбирая
конкретный вариант completion (он при этом при наведении мышки он должен
перекраситься и отобразиться другим face - background и foreground меняются
местами). В целом и общем - помогает способ остерегаться таких faces и не
наводить мышку куда попало. Иногда описанное поведение происходит и с другими
программами, в первую очередь - теми, которые используют частями или целиком
некие библиотеки, отличные от Qt/Gtk, т.е. motif (xpdf), Xaw, fltk и т.п.

Архитектура - x86_64, все пакеты xorg - из Сизифа на 2006-12-03, а именно xfs -
xorg-x11-xfs-1.0.3-alt1.

В xorg.conf:

Section "Files"
    RgbPath         "/usr/share/X11/rgb"
    FontPath        "unix/:-1"
EndSection

/etc/X11/fs/config в аттаче.
------- Comment #1 From 2006-12-03 13:47:28 -------
Created an attachment (id=1696) [details]
/etc/X11/fs/config
------- Comment #2 From 2006-12-03 16:04:47 -------
могу предложить только apt-get remove xorg-x11-xfs
------- Comment #3 From 2006-12-03 16:34:27 -------
может тогда все-таки не будем его собирать, и, соответственно, все имеет смысл
поставить вопрос о том, что все утилиты, как либо генерящие конфиги X-сервера,
по умолчанию бы не добавляли только unix:/-1?
------- Comment #4 From 2006-12-03 16:49:07 -------
не собирать мы его не будем, мало ли, может кому то действительно нужен X Font 
Server (именно сервер). а вот про то что бы конфиги генерились без FontPath я 
говорю уже года 2
------- Comment #5 From 2006-12-03 17:19:27 -------
где-то в xfs есть ошибка - судя по ее характеру - это memory corruption; любая
ошибка такого рода - security breach, как минимум - DoS (что, собственно, уже и
продемонстрировано), а вообще - и local code execution.

если xfs сейчас де-факто не поддерживается (судя по совету сделать apt-get
remove) - мне кажется, что лучше его не собирать.

а насчет генерации конфигов - от кого это зависит? баги на соответствующих
пакетах уже висят / повесим?
------- Comment #6 From 2006-12-03 17:21:45 -------
баги висят, только вот вопрос - что сейчас является генератором конфигов?
------- Comment #7 From 2006-12-03 17:41:13 -------
а можно показать пример, как должна выглядеть секция Files с FontPath для
конфигурации без xfs? там все эти paths должны быть перечислены или вообще
ничего - все через fontconfig?
------- Comment #8 From 2006-12-03 17:45:11 -------
FontPath вообще не должно быть, каталоги со шрифтами берутся 
из /etc/X11/fs/config (см. /etc/X11/xinit.d/xfonts)
------- Comment #9 From 2006-12-04 01:08:34 -------
Понял, спасибо. Хочу только обратить внимание, что в дефолтном конфиге
/etc/sysconfig/xfs в xorg-x11-xfs-1.0.3-alt1, xfs включен:
#
# Arguments for xfs init script
#

ARGS="-port -1 -daemon -user xfs"
XFS=yes

А в самом скрипте /etc/init.d/xfs:

#!/bin/sh
#
# xfs:       Starts/Stops the X Font Server
#
# chkconfig: 2345 44 10
# description: Starts and stops the X Font Server at boot time and shutdown.

Т.е. сервис включается автоматически при инсталляции.
------- Comment #10 From 2007-01-18 22:30:24 -------
Закрыл баг, по крайней мере пока, как WONTFIX - по факту так.
------- Comment #11 From 2008-03-14 03:34:15 -------
WONTFIX, а при этом в жтой документации
http://www.freesource.info/wiki/AltLinux/Dokumentacija/NastrojjkaServeraPrilozhenijj&
описана ситуация, когда xfs используется.